# coding: utf-8

"""
    Forgejo API

    This documentation describes the Forgejo API.

    The version of the OpenAPI document: 10.0.0-93-60eedb9+gitea-1.22.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from clientapi_forgejo.models.quota_used_attachment_contained_in import QuotaUsedAttachmentContainedIn
from typing import Optional, Set
from typing_extensions import Self

class QuotaUsedAttachment(BaseModel):
    """
    QuotaUsedAttachment represents an attachment counting towards a user's quota
    """ # noqa: E501
    api_url: Optional[StrictStr] = Field(default=None, description="API URL for the attachment")
    contained_in: Optional[QuotaUsedAttachmentContainedIn] = None
    name: Optional[StrictStr] = Field(default=None, description="Filename of the attachment")
    size: Optional[StrictInt] = Field(default=None, description="Size of the attachment (in bytes)")
    __properties: ClassVar[List[str]] = ["api_url", "contained_in", "name", "size"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of QuotaUsedAttachment from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of contained_in
        if self.contained_in:
            _dict['contained_in'] = self.contained_in.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of QuotaUsedAttachment from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "api_url": obj.get("api_url"),
            "contained_in": QuotaUsedAttachmentContainedIn.from_dict(obj["contained_in"]) if obj.get("contained_in") is not None else None,
            "name": obj.get("name"),
            "size": obj.get("size")
        })
        return _obj


